// MicrosoftStack.h: interface for the CMicrosoftStack class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MICROSOFTSTACK_H__32F7E50E_3000_44B8_BA3A_CC72401871A0__INCLUDED_)
#define AFX_MICROSOFTSTACK_H__32F7E50E_3000_44B8_BA3A_CC72401871A0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <vector>
#include "msbts.h"
#include "SdpDiscovery.h"
#include "SdpRecord.h"


typedef std::vector<CSdpRecord*> CDiscovery;


class CMicrosoftStack  
{
public:
	CMicrosoftStack();
	virtual ~CMicrosoftStack();

	BOOL		StartInquiry();
	void		StopInquiry();
	BOOL		StartDiscovery(BTH_ADDR btAddr, GUID *pGuid);
	CDiscovery*	GetDiscovery()		{ return &m_vecSdpRec; }

	void	NotifyWindow(HWND hWnd, UINT nMsg) { m_hWnd = hWnd; m_nMsg = nMsg; }

	int			GetSdpRecordCount	()				{ return (int)m_vecSdpRec.size();	}
	CSdpRecord*	GetSdpRecord		(int iRecord)	{ return m_vecSdpRec[iRecord];		}

protected:
	HANDLE		m_hThread;
	DWORD		m_dwThreadID;
	bool		m_bStopThread;
	HWND		m_hWnd;
	UINT		m_nMsg;
	WSADATA		m_wsaData;
	BTH_ADDR	m_btAddr;
	GUID		m_guid;

	CDiscovery	m_vecSdpRec;

	void	ClearDiscovery();

	DWORD	FindDevices();
	DWORD	DiscoverServices(BTH_ADDR btAddr, GUID *pGuid);

	HRESULT	ParseBlobsToRecs(UCHAR *pbData, DWORD cbStream, ISdpRecord ***pppSqpRecords, ULONG *pcbRec);

	static DWORD FindDevicesThread		(void *pVoid);
	static DWORD DiscoverServicesThread	(void *pVoid);
};

#endif // !defined(AFX_MICROSOFTSTACK_H__32F7E50E_3000_44B8_BA3A_CC72401871A0__INCLUDED_)
