// msbts.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "msbts.h"
#include "MicrosoftStack.h"
#include "NodeData.h"

HMODULE g_hModule = NULL;


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

/*

// This is an example of an exported variable
MSBTS_API int nMsbts=0;

// This is an example of an exported function.
MSBTS_API int fnMsbts(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see msbts.h for the class definition
CMsbts::CMsbts()
{ 
	return; 
}

*/



MSBTS_API int MicrosoftStackPresent()
{
/*	int nRet,
		nStatus;

	nRet = BthGetHardwareStatus(&nStatus);
	if(nRet == ERROR_SUCCESS)
		return nStatus;
	return nRet;*/

	return 1;
}




MSBTS_API void* CreateStack()
{
	if(g_hModule == NULL)
		g_hModule = LoadLibrary(L"msbts.dll");

	return new CMicrosoftStack();
}


MSBTS_API void DeleteStack(void *pStack)
{
	CMicrosoftStack*	pMsStack = (CMicrosoftStack*)pStack;

	if(pMsStack)
		delete pMsStack;

	if(g_hModule != NULL)
	{
		FreeLibrary(g_hModule);
		g_hModule = NULL;
	}
}


MSBTS_API void StackNotifyWindow(void *pStack, HWND hWnd, UINT nMsg)
{
	CMicrosoftStack*	pMsStack = (CMicrosoftStack*)pStack;

	if(pMsStack)
		pMsStack->NotifyWindow(hWnd, nMsg);
}


MSBTS_API BOOL StackStartInquiry(void *pStack)
{
	CMicrosoftStack*	pMsStack = (CMicrosoftStack*)pStack;

	if(pMsStack)
		return pMsStack->StartInquiry();
	return FALSE;
}


MSBTS_API void StackStopInquiry(void *pStack)
{
	CMicrosoftStack*	pMsStack = (CMicrosoftStack*)pStack;

	if(pMsStack)
		pMsStack->StopInquiry();
}


MSBTS_API BOOL StackStartDiscovery(void *pStack, ULONGLONG address, GUID *pGuid)
{
	CMicrosoftStack*	pMsStack = (CMicrosoftStack*)pStack;

	if(pMsStack)
		return pMsStack->StartDiscovery(address, pGuid);

	return FALSE;
}


MSBTS_API void* StackGetDiscovery(void *pStack, ULONGLONG address, GUID *pGuid)
{
	CMicrosoftStack*	pMsStack = (CMicrosoftStack*)pStack;

	if(pMsStack)
		return pMsStack->GetDiscovery();

	return NULL;
}



MSBTS_API int DiscoveryGetSdpRecCount(void *pDisc)
{
	CDiscovery*	pDiscovery = (CDiscovery*)pDisc;

	if(pDiscovery)
		return (int)pDiscovery->size();
	return 0;
}



MSBTS_API void* DiscoveryGetSdpRec(void *pDisc, int iService)
{
	CDiscovery*	pDiscovery = (CDiscovery*)pDisc;

	if(pDiscovery)
		return pDiscovery->operator[](iService);
	return NULL;
}


MSBTS_API void DeleteDiscovery(void *pDisc)
{
}


//---------------------------------------------------------------------------
//
// SdpRecord API
//
//---------------------------------------------------------------------------

MSBTS_API BOOL SdpRecFindRFCommChannel(void *pSdp, ULONG *pChannel)
{
	CSdpRecord*	pSdpRec = (CSdpRecord*)pSdp;

	if(pSdpRec)
	{
		if(pSdpRec->FindRFCommChannel(*pChannel))
			return TRUE;
	}

	return FALSE;
}


MSBTS_API BOOL SdpRecFindServiceName(void *pSdp, TCHAR *pszName, int nNameLen)
{
	CSdpRecord*	pSdpRec = (CSdpRecord*)pSdp;

	if(pSdpRec)
	{
		CNodeData	nodeData;

		if(pSdpRec->GetAttributeData(0x0100, &nodeData) == S_OK)
		{
			TCHAR*	pszServiceName = nodeData.ToString();

			wcscpy(pszName, pszServiceName);
			return TRUE;
		}
	}

	return FALSE;
}


MSBTS_API BOOL SdpRecFindServiceClass(void *pSdp, GUID *pGuid)
{
	CSdpRecord*	pSdpRec = (CSdpRecord*)pSdp;

	if(pSdpRec)
		return pSdpRec->FindServiceClass(pGuid);

	return FALSE;
}
