#ifndef _MSBTS_H_
#define _MSBTS_H_

#ifdef MSBTS_EXPORTS
#define MSBTS_API __declspec(dllexport)
#else
#define MSBTS_API __declspec(dllimport)
#endif

/*
// This class is exported from the msbts.dll
class MSBTS_API CMsbts {
public:
	CMsbts(void);
	// TODO: add your methods here.
};

extern MSBTS_API int nMsbts;

MSBTS_API int fnMsbts(void);

*/


extern "C" {


#define BLUETOOTH_MAX_NAME_SIZE 248

typedef ULONGLONG BTH_ADDR;

typedef struct _BLUETOOTH_ADDRESS
{
	union
	{
		BTH_ADDR	ullLong;
		BYTE		rgBytes[6];  
	};
} BLUETOOTH_ADDRESS;


typedef struct _BLUETOOTH_DEVICE_INFO
{
	DWORD				dwSize;
	BLUETOOTH_ADDRESS	Address;
	ULONG				ulClassofDevice;
	BOOL				fConnected;
	BOOL				fRemembered;
	BOOL				fAuthenticated;
	SYSTEMTIME			stLastSeen;
	SYSTEMTIME			stLastUsed;
	WCHAR				szName[BLUETOOTH_MAX_NAME_SIZE];
} BLUETOOTH_DEVICE_INFO;


typedef struct _BLUETOOTH_SPP_INFO
{
	BLUETOOTH_ADDRESS	Address;
	ULONG				ulClassofDevice;
	BOOL				fConnected;
	short				nPort;
	WCHAR				szName[BLUETOOTH_MAX_NAME_SIZE];
} BLUETOOTH_SPP_INFO;


typedef void (*DeviceRespondedCallback)(BLUETOOTH_DEVICE_INFO *pBtDevInfo);
typedef void (*InquiryCompleteCallback)(BOOL, short);
typedef void (*DiscoveryCompleteCallback)();
typedef void (*SppServerCallback)(BLUETOOTH_SPP_INFO *pBtSppInfo);


//---------------------------------------------------------------------------
//
// Stack API
//
//---------------------------------------------------------------------------

MSBTS_API	int		MicrosoftStackPresent();		// BthGetHardwareStatus

MSBTS_API	void*	CreateStack();
MSBTS_API	void	DeleteStack			(void *pStack);
MSBTS_API	void	StackNotifyWindow	(void *pStack, HWND hWnd, UINT nMsg);
MSBTS_API	BOOL	StackStartInquiry	(void *pStack);
MSBTS_API	void	StackStopInquiry	(void *pStack);
MSBTS_API	BOOL	StackStartDiscovery	(void *pStack, ULONGLONG address, GUID *pGuid);

MSBTS_API	void*	StackGetDiscovery	(void *pStack, ULONGLONG address, GUID *pGuid);


//---------------------------------------------------------------------------
//
// Discovery API
//
//---------------------------------------------------------------------------

MSBTS_API	int		DiscoveryGetSdpRecCount	(void *pDisc);
MSBTS_API	void*	DiscoveryGetSdpRec		(void *pDisc, int iRecord);
MSBTS_API	void	DeleteDiscovery			(void *pDisc);


//---------------------------------------------------------------------------
//
// SdpRecord API
//
//---------------------------------------------------------------------------

MSBTS_API	BOOL	SdpRecFindRFCommChannel	(void *pSdp, ULONG *pChannel);
MSBTS_API	BOOL	SdpRecFindServiceName	(void *pSdp, TCHAR *pszName, int nNameLen);
MSBTS_API	BOOL	SdpRecFindServiceClass	(void *pSdp, GUID *pGuid);


};

#endif
